=== added file 'src/com/goldencode/p2j/schema/TableInfo.java'
--- old/src/com/goldencode/p2j/schema/TableInfo.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/schema/TableInfo.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : TableInfo.java
+** Abstract : Schema information about a database field.
+**
+** Copyright (c) 2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- --------------------------------Description----------------------------------
+** 001 GES 20210224 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.schema;
+
+/**
+ * A read-only bean which exposes schema-related information associated with a database table
+ * which is referenced in source code.
+ */
+public class TableInfo
+{
+   /** Table signature associated with the table. */
+   private final String signature;
+   
+   /** Fully qualified schema name of the table. */
+   private final String qualified;
+   
+   /** Table's buffer name as indicated in source. */
+   private final String buffer;
+   
+   /** Table's database logical name or alias. */
+   private final String database;
+   
+   /** Table's token type. */
+   private final int recordType;
+   
+   /**
+    * Constructor.
+    * 
+    * @param   signature
+    *          Structural signature for the table.
+    * @param   qualified
+    *          Fully qualified schema name of the table.
+    * @param   buffer
+    *          Name of the buffer indicated by the table reference in source code.
+    * @param   database
+    *          Name of the database which contains the table, as specified by the table reference
+    *          in source code, or looked up if the source reference was unqualified.
+    * @param   recordType
+    *          Token type of the table backing the buffer indicated by the table reference in
+    *          source code.
+    */
+   TableInfo(String signature, String qualified, String buffer, String database, int recordType)
+   {
+      this.signature  = signature;
+      this.qualified  = qualified;
+      this.buffer     = buffer;
+      this.database   = database;
+      this.recordType = recordType;
+   }
+   
+   /**
+    * Get the signature of the table in the schema.
+    * 
+    * @return   Table signature.
+    */
+   public String getSignature()
+   {
+      return signature;
+   }
+   
+   /**
+    * Get the fully qualified schema name of the field.
+    * 
+    * @return  Qualified field name.
+    */
+   public String getQualified()
+   {
+      return qualified;
+   }
+   
+   /**
+    * Get the buffer name associated with the field.
+    * 
+    * @return  Buffer name.
+    */
+   public String getBuffer()
+   {
+      return buffer;
+   }
+   
+   /**
+    * Get the logical database name or alias, if any, associated with the field.
+    * 
+    * @return  The logical name of the database associated with the buffer associated with the
+    *          field. An empty string is returned if the containing table is a temp- or
+    *          work-table.
+    */
+   public String getDatabase()
+   {
+      return database;
+   }
+   
+   /**
+    * Get the Progress parser token type of a table, temp-table, work-table, or buffer which
+    * contains the field. If the record containing the field is a buffer, the type of the backing
+    * record is returned. That is, a type of {@code BUFFER} is never returned, only the type of
+    * the record which backs the buffer.
+    * 
+    * @return  Record token type.
+    */
+   public int getRecordType()
+   {
+      return recordType;
+   }
+}
\ No newline at end of file

=== modified file 'src/com/goldencode/p2j/schema/schema.g'
--- old/src/com/goldencode/p2j/schema/schema.g	2022-04-29 11:01:19 +0000
+++ new/src/com/goldencode/p2j/schema/schema.g	2022-05-12 15:31:40 +0000
@@ -99,10 +99,11 @@
 ** 037 OM  20200530          Fix for datetime[tz].
 ** 038 CA  20200930          Use factory.setASTNodeClass(Class) instead of setASTNodeClass(String), to avoid
 **                           loadClass call.
-** 039 OM  20211122          Added hints-based support for 'unloading' schema.
+**     OM  20211122          Added hints-based support for 'unloading' schema.
 **     GES 20220429          Allow sequences and tables to be intermixed such that sequences do not have to
 **                           precede tables. The 4GL seems to allow this (at least schemata provided by
 **                           customers in compilable applications shows this behavior).
+**     GES 20210208          Added table-level signature calculation and it is saved as an annotation.
 */
 
 /*
@@ -245,6 +246,99 @@
    }
    
    /**
+    * Calculate the signature string for a field.
+    *
+    * @param    type
+    *           The field's data type.
+    * @param    extent
+    *           The extent size (as a num literal) or {@code null} if the field is scalar.
+    *
+    * @return   The signature in "datatype" or "datatype[extent]" format.
+    */
+   public static String fieldSignature(int type, String extent)
+   {
+      String code = null;
+      
+      switch (type)
+      {
+         case FIELD_BLOB:
+            code = "blob";
+            break;
+         case FIELD_CHAR:
+            code = "char";
+            break;
+         case FIELD_CLOB:
+            code = "clob";
+            break;
+         case FIELD_COM_HANDLE:
+            code = "comh";
+            break;
+         case FIELD_DATE:
+            code = "date";
+            break;
+         case FIELD_DATETIME:
+            code = "dt";
+            break;
+         case FIELD_DATETIME_TZ:
+            code = "dttz";
+            break;
+         case FIELD_DEC:
+            code = "dec";
+            break;
+         case FIELD_INT:
+            code = "int";
+            break;
+         case FIELD_INT64:
+            code = "i64";
+            break;
+         case FIELD_LOGICAL:
+            code = "log";
+            break;
+         case FIELD_RECID:
+            code = "rec";
+            break;
+         case FIELD_ROWID:
+            code = "row";
+            break;
+         case FIELD_RAW:
+            code = "raw";
+            break;
+         case FIELD_HANDLE:
+            code = "hndl";
+            break;
+         case FIELD_BIGINT:
+            code = "bigi";
+            break;
+         case FIELD_BYTE:
+            code = "byte";
+            break;
+         case FIELD_DOUBLE:
+            code = "dbl";
+            break;
+         case FIELD_FIXCHAR:
+            code = "fixc";
+            break;
+         case FIELD_FLOAT:
+            code = "flt";
+            break;
+         case FIELD_SHORT:
+            code = "shrt";
+            break;
+         case FIELD_TIMESTAMP:
+            code = "tmst";
+            break;
+         case FIELD_TIME:
+            code = "time";
+            break;
+         default:
+            code = "unkw";
+            break;
+      }
+      
+      return (extent == null) ? code : code + "[" + extent + "]";
+   }
+   
+   /**
     * Configure the hidden filter to ensure that token types that are not
     * normally recognized by the parser, are hidden (but still accessible)
     * using the filter.
@@ -703,7 +797,11 @@
  */
 table
    :
-      { astFactory.makeASTRoot(currentAST, #[TABLE]); }
+      {
+         astFactory.makeASTRoot(currentAST, #[TABLE]);
+         String signature = "";
+         String fsig = null;
+      }
       (
          KW_ADD! tab:KW_TABLE! s:STRING! (y:KW_TYPE! d:SYMBOL!)?
          {
@@ -726,13 +824,17 @@
          (
             options { generateAmbigWarnings = false; }
             :
-              field
+              fsig=field
+              {
+                 signature += (signature.length() == 0) ? fsig : "|" + fsig;
+              }
             | index
          )*
       )
       {
          currentTable = null;
          forceLineColumnNums(#tab, ##);
+         ##.putAnnotation("db_signature", signature);
       }
    ;
    
@@ -807,15 +909,18 @@
  * definition would always be a child of the most recently parsed table
  * definition.
  *
- * @throws  SemanticException
- *          if this field definition reports a different parent table name
- *          from the table definition most recently parsed.
+ * @return   The signature for this field in "datatype" or "datatype[extent]" format.
+ *
+ * @throws   SemanticException
+ *           if this field definition reports a different parent table name
+ *           from the table definition most recently parsed.
  */
-field
+field returns [String sig = null]
    :
       {
          int    ftype;
          String fmt = null;
+         String ext = null;
       }
       (
          KW_ADD! f:KW_FIELD^ s:STRING!
@@ -853,7 +958,7 @@
             | field_trigger
             | help
             | help_sa
-            | extent
+            | ext=extent
             | decimals
             | length
             | viewAs
@@ -879,6 +984,9 @@
             | unknownOption!
          )*
       )
+      {
+         sig = fieldSignature(ftype, ext);
+      }
    ;
    
 /**
@@ -1739,10 +1847,12 @@
  * <p>
  * The resulting sub-tree is the <code>KW_EXTENT</code> with a child of
  * <code>NUM_LITERAL</code>.
+ *
+ * @return   The size of the extent.
  */
-extent
+extent returns [String num = null]
    :
-      KW_EXTENT^ NUM_LITERAL
+      KW_EXTENT^ n:NUM_LITERAL { num = #n.getText(); }
    ;
    
 /**

=== modified file 'src/com/goldencode/p2j/uast/AstGenerator.java'
--- old/src/com/goldencode/p2j/uast/AstGenerator.java	2022-05-01 17:28:59 +0000
+++ new/src/com/goldencode/p2j/uast/AstGenerator.java	2022-05-19 13:32:07 +0000
@@ -178,6 +178,7 @@
 **     OM  20210913          Added flags capability to AST registry.
 **     OM  20211122          Added hints-based support for 'unloading' schema.
 **     OM  20220405          XmlFilePlugin can load resources from application's jar.
+**     GES 20220517          Added getAstName().
 */
 
 /*
@@ -941,6 +942,7 @@
       try
       {
          // exclude all other access to this file
+         // TODO: doesn't this locking need to be on filename.ast instead of just filename?
          mgr.lockTree(filename, list != null);
          
          // should we honor a previously persisted AST?
@@ -1028,6 +1030,19 @@
    }
    
    /**
+    * Given a 4GL source code filename return the name of the AST file.
+    *
+    * @param    filename
+    *           The original source filename.
+    *
+    * @return   The target AST filename.
+    */   
+   public static String getAstName(String filename)
+   {
+      return filename + AST_POSTFIX;
+   }
+   
+   /**
     * Builds a unique filename based on an original filename and a passed
     * postfix.  This method takes the original filename and appends a fixed
     * value to create a new, unique cache filename.

